<?php
////////////////////// add meta boxs for page and posts
add_action( 'add_meta_boxes', 'page_builder_meta_boxs' );
/* Do something with the data entered */
add_action( 'save_post', 'page_builder_save_postdata' );
/* Adds a box to the main column on the Post and Page edit screens */
function page_builder_meta_boxs() {
	$screens = array( 'post', 'page' );
    foreach ($screens as $screen) {
        add_meta_box('page_builder_meta',__('Page builder', 'bage-builder'),'page_builder_metadate', $screen );
	}
}
/* Prints the box content */
function page_builder_metadate( $post ) {
  wp_nonce_field( plugin_basename( __FILE__ ), 'page_builder_noncename' );  
  $page_builder_hid 		= get_post_meta( $post->ID, '_page_builder_hid_meta_value', true );
  $page_builder_hid_width 	= get_post_meta( $post->ID, '_page_builder_hid_width_meta_value', true );
  $page_builder_hid_position	= get_post_meta( $post->ID, '_page_builder_hid_position_meta_value', true );

?>
<div class="page_build_param" id="page_build_wrap_page_builder">     
  <div class="page_build_diagram page_build_diagram_page_builder last_builder" id="page_build_diagram_page_builder_0">
	<!-- builder TITLE -->
	<div class="diagram-from-base_title">
	  <div  valign="middle">
		<h3><?php esc_html_e("Sidebar ID", "bage-builder"); ?></h3>
	  </div>
	  <div><input  type="text" id="page_builder_title_0" class="diagram_title_group" value="" /></div>
	</div>
	<div class="diagram-from-base_desc">
	  <div  valign="middle">
		<h3><?php esc_html_e("Width", "page-builder"); ?></h3>
	  </div>
	  <div><input type="number" class="diagram_builder_group" id="page_builder_builder_0"  value="" min="1" max="100" step="0.2"/>% </div>
	</div>
	<!-- builder DESCRIPTION -->
	<div class="diagram-from-base_position" style="margin-bottom:3%;">
	  <div valign="middle">
		<h3><?php esc_html_e("Position", "page-builder"); ?></h3>
	  </div>
	  <div>
		<select id="page_builder_position_0" class="diagram_position_group">
			<option value="">Choose</option>
			<option value="left">Left</option>
			<option value="right">Right</option>
		</select>
		<input type="button" class="page_builder_remove-builder page_build_btn_red" id="page_builder_remove-button_0" value="<?php esc_attr_e("Remove this", ""); ?>"  />
	  </div>
	</div>
	
  </div>
  
  <div class="diagram-controls">
	<div>
	  <input type="hidden" name="page_builder_hid" id="page_builder_titles" data-customize-setting-link="page_builder_hid" value="<?php echo esc_attr($page_builder_hid); ?>" >
	  <input type="hidden" name="page_builder_hid_width" id="page_builder_builders" data-customize-setting-link="page_builder_hid_width" value="<?php echo esc_attr($page_builder_hid_width); ?>" >
	  <input type="hidden" name="page_builder_hid_position" id="page_builder_positions" data-customize-setting-link="page_builder_hid_position" value="<?php echo esc_attr($page_builder_hid_position); ?>" >
	  <input class="add_builder page_build_btn_blue" type="button" id="page_builder_add-button" value="<?php esc_attr_e('Add new builder value', ""); ?>" />
	</div>
  </div>
</div>

<style>
	.page_build_diagram_page_builder{
		border-bottom: 1px solid #BCBCBC;
	}
	.page_build_diagram_page_builder > div{
		width: 30%;
		display: inline-block;		
	}
	
	#page_build_wrap_page_builder >div.last_builder{
		border: 0;
	}

</style>
<script>
var page_build_elements = {
diagram : {
    len : function(titles_together){
      var titles = titles_together.split(this.delimiter);
      return titles.length;
    },
    reset_diagram: function(element){
      /*copy and paste builder controls, modyfy only IDs*/
      for(var i = 1; i< element.number_builders; i++){
        jQuery("#page_build_diagram_"+element.id+"_"+i).remove();
      }
      jQuery(".page_build_diagram_"+element.id).eq(0).prop('class', "page_build_diagram page_build_diagram_"+element.id + " last_builder");
    },
    init : function(element){
      /*copy and paste builder controls, modyfy only IDs*/
      for(var i = 0; i< element.number_builders-1; i++){
        jQuery(".page_build_diagram_"+element.id+".last_builder").clone().insertAfter(".page_build_diagram_"+element.id+".last_builder");
        jQuery(".page_build_diagram_"+element.id+".last_builder").eq(0).prop('class', "page_build_diagram page_build_diagram_"+element.id);
        jQuery(".page_build_diagram_"+element.id+".last_builder").prop('id', "page_build_diagram_"+element.id+"_"+(i+1));
        jQuery(".page_build_diagram_"+element.id+".last_builder").find("#"+element.id+"_title_"+i).prop('id', element.id+"_title_"+(i+1));
        jQuery(".page_build_diagram_"+element.id+".last_builder").find("#"+element.id+"_builder_"+i).prop('id', element.id+"_builder_"+(i+1));
		    jQuery(".page_build_diagram_"+element.id+".last_builder").find("#"+element.id+"_position_"+i).prop('id', element.id+"_position_"+(i+1));
        jQuery(".page_build_diagram_"+element.id+".last_builder").find("#"+element.id+"_remove-button_"+i).prop('id', element.id+"_remove-button_"+(i+1));
      }

    },
    show : function(element){
      var titles = element.titles.split(this.delimiter);
      var builders = element.builders.split(this.delimiter);
	    var positions = element.positions.split(this.delimiter);

      /*refresh values in visible inputs*/
      for(var i = 0; i< element.number_builders; i++){
        jQuery("#"+element.id+"_title_"+i).val(this.esc_attr_chars(titles[i]));
        jQuery("#"+element.id+"_builder_"+i).val(this.esc_attr_chars(builders[i]));
		jQuery("#"+element.id+"_position_"+i).val(this.esc_attr_chars(positions[i]));
      }
    },
    insert : function(element, index, new_title){
      element.active = index;
      element.number_builders++;
      var titles = element.titles.split(this.delimiter);
      var builders = element.builders.split(this.delimiter);
	  var positions = element.positions.split(this.delimiter);
      titles.splice(index+1, 0, "");
      builders.splice(index+1, 0, "");
	  positions.splice(index+1, 0, "");
      element.titles = titles.join(this.delimiter);
      element.builders = builders.join(this.delimiter);
	  element.positions = positions.join(this.delimiter);
      this.reset_diagram(element);
      this.init(element);
      this.show(element);
      this.update(element, "inserted");
    },
    remove : function(element){
      var index = element.active;
      if(element.number_builders > 1){
        this.reset_diagram(element);
        element.number_builders--;
      }
      else{
        /*no alert, just does not remove*/
        return;
      }
      if(element.active != 0){
        element.active--;
      };
      var titles = element.titles.split(this.delimiter);
      var builders = element.builders.split(this.delimiter);
	  var positions = element.positions.split(this.delimiter);
      titles.splice(index, 1);
      builders.splice(index, 1);
	  positions.splice(index, 1);
      element.titles = titles.join(this.delimiter);
      element.builders = builders.join(this.delimiter);
	  element.positions = positions.join(this.delimiter);
      
      this.init(element);
      this.show(element);
      this.update(element, "deleted");

    },
    edit : function(element, index, param_edited){
      /*called when user edits inputs
        changes the value of element object and hidden inputs
      */
      switch(param_edited) {		  
        case 'title':
          var titles = element.titles.split(this.delimiter);
          titles[index] = this.esc_attr_chars(jQuery("#"+element.id+"_title_"+index).val());
          element.titles = titles.join(this.delimiter);
          /*update hidden fields and trigger chahges*/
          this.update(element, 'title');
          break;
        case 'builder':
          var builders = element.builders.split(this.delimiter);
          builders[index] = this.esc_attr_chars(jQuery("#"+element.id+"_builder_"+index).val());
          element.builders = builders.join(this.delimiter);
          /*update hidden fields and trigger chahges*/
          this.update(element, 'builder');
          break;
		case 'position':
          var positions = element.positions.split(this.delimiter);
          positions[index] = this.esc_attr_chars(jQuery("#"+element.id+"_position_"+index).val());
          element.positions = positions.join(this.delimiter);
          /*update hidden fields and trigger chahges*/
          this.update(element, 'position');
          break;
        default:
          /*do nothing*/
      }

    },
    delimiter : "||wd||",
    update : function(element, param_edited){
      switch(param_edited) {
        case 'title':
          jQuery("#"+element.id+"_titles").val(element.titles);
          jQuery("#"+element.id+"_titles").change();
          break;
        case 'builder':
          jQuery("#"+element.id+"_builders").val(element.builders);
          jQuery("#"+element.id+"_builders").change();
          break;
		case 'position':
          jQuery("#"+element.id+"_positions").val(element.positions);
          jQuery("#"+element.id+"_positions").change();
          break;
        case "inserted":
        case "deleted":
          jQuery("#"+element.id+"_titles").val(element.titles);
          jQuery("#"+element.id+"_builders").val(element.builders);
		  jQuery("#"+element.id+"_positions").val(element.positions);
          jQuery("#"+element.id+"_titles").change();
          jQuery("#"+element.id+"_builders").change();
		  jQuery("#"+element.id+"_positions").change();
          break;
        default:
        /*do nothing*/
      }
    },
    esc_attr_chars : function(str){

    return str;
    },
    find_index : function(dom_element, id_base){
      var elem_id = dom_element.prop("id");
      var st = id_base.length;
      var end = elem_id.length;
      var index = Number(elem_id.substring(st, end));
      return index;
    } 

  }
}
  jQuery(document).ready(function(){ 

      var element_page_builder = {
        id : "page_builder",
        titles : jQuery('#page_builder_titles').val(),
        builders : jQuery('#page_builder_builders').val(),
		positions : jQuery('#page_builder_positions').val(),
        active : 0,
        number_builders :  page_build_elements.diagram.len(jQuery('#page_builder_titles').val()),
        };
      /*init show*/
      page_build_elements.diagram.init(element_page_builder);
      page_build_elements.diagram.show(element_page_builder);
      /*watch for changes in values*/
      jQuery("#page_build_wrap_page_builder").on("change", ".diagram_title_group", function (){
        var index = page_build_elements.diagram.find_index(jQuery(this), "page_builder_title_");
        page_build_elements.diagram.edit(element_page_builder, index,  "title");
      });
      jQuery("#page_build_wrap_page_builder").on("change", ".diagram_builder_group", function (){
        var index = page_build_elements.diagram.find_index(jQuery(this), "page_builder_builder_");
        page_build_elements.diagram.edit(element_page_builder, index, "builder");
      });
	  jQuery("#page_build_wrap_page_builder").on("change", ".diagram_position_group", function (){
        var index = page_build_elements.diagram.find_index(jQuery(this), "page_builder_position_");
        page_build_elements.diagram.edit(element_page_builder, index, "position"); 
      });
      /*add new builder*/
      jQuery("#page_builder_add-button").on('click', function(){
        after = element_page_builder.number_builders-1;
        page_build_elements.diagram.insert(element_page_builder, after, '');
      });
      /*remove builder*/
      jQuery("#page_build_wrap_page_builder").on('click', ".page_builder_remove-builder", function(){
        var index = page_build_elements.diagram.find_index(jQuery(this), "page_builder_remove-button_");                
        element_page_builder.active = index;
        page_build_elements.diagram.remove(element_page_builder);
      });
    });
</script>
  <?php
}
/* When the post is saved, saves our custom data */
function page_builder_save_postdata( $post_id ) {
  if(isset($_POST['post_type']))
  if ( 'page' == $_POST['post_type']) {
    if ( ! current_user_can( 'edit_page', $post_id ) )
        return;
  } else {
    if ( ! current_user_can( 'edit_post', $post_id ) )
        return;
  }
  // Secondly we need to check if the user intended to change this value.
  if ( ! isset( $_POST['page_builder_noncename'] ) || ! wp_verify_nonce( $_POST['page_builder_noncename'], plugin_basename( __FILE__ ) ) )
      return $post_id;
  // Thirdly we can save the value to the database
  

    $page_builder_hid = '';
	
	if(isset($_POST['page_builder_hid']))
		$page_builder_hid=sanitize_text_field($_POST['page_builder_hid']);
		
  	add_post_meta($post_id, '_page_builder_hid_meta_value', $page_builder_hid, true) or   update_post_meta($post_id, '_page_builder_hid_meta_value', $page_builder_hid);    
	
	$page_builder_hid_width = '';
	
	if(isset($_POST['page_builder_hid_width']))
		$page_builder_hid_width=sanitize_text_field($_POST['page_builder_hid_width']);
		
  	add_post_meta($post_id, '_page_builder_hid_width_meta_value', $page_builder_hid_width, true) or   update_post_meta($post_id, '_page_builder_hid_width_meta_value', $page_builder_hid_width); 
	
	$page_builder_hid_position = '';
	
	if(isset($_POST['page_builder_hid_position']))
		$page_builder_hid_position=sanitize_text_field($_POST['page_builder_hid_position']);
		
  	add_post_meta($post_id, '_page_builder_hid_position_meta_value', $page_builder_hid_position, true) or   update_post_meta($post_id, '_page_builder_hid_position_meta_value', $page_builder_hid_position); 	
		
}
